/*
  Copyright 2006-2020 Damien Stehl, Paul Zimmermann.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; see the file COPYING.  If not, write to the Free
  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/

#include <stdlib.h>
#include <gmp.h>
#include "heuristic.h"

void
allocate_space_heuristic (mpz_t ***B, int d, int n)
{
  int i, j;

  *B        = (mpz_t**) malloc (d*sizeof (mpz_t *));
 
  for (i=0; i<d; i++){
    (*B)[i]     = (mpz_t*) malloc (n*sizeof (mpz_t));
    for (j=0; j<n; j++)
      mpz_init ((*B)[i][j]);
  }
}

void
free_space_heuristic (mpz_t ***B, int d, int n)
{
  int i, j;

  for (i=0; i<d; i++){
    for (j=0; j<n; j++)
      mpz_clear ((*B)[i][j]);
    free ((*B)[i]);
  }

  free (*B);
}
